unit ColorU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Spin, StdCtrls, ExtCtrls;

const HEXA : string = '0123456789ABCDEF';

type
  TForm1 = class(TForm)
    HTMLMemo: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    KleComboBox: TComboBox;
    SavButton: TButton;
    KleSpinEdit: TSpinEdit;
    BreSpinEdit: TSpinEdit;
    Label4: TLabel;
    KleLabel: TLabel;
    CreButton: TButton;
    NormalMemo: TMemo;
    Hoogte: TLabel;
    HooLabel: TLabel;
    SaveDialog: TSaveDialog;
    BotMemo: TMemo;
    RadioGroup1: TRadioGroup;
    DarkMemo: TMemo;
    LightMemo: TMemo;
    procedure CreButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Exit(Sender: TObject);
    procedure SavButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Exit(Sender);
end;

procedure TForm1.CreButtonClick(Sender: TObject);
var
  i, j, k, teller, index : integer;
  si, sj, sk, s, tekst : string[48];
begin
  teller := 0;
  index := RadioGroup1.ItemIndex;
  HTMLMemo.Clear;
  case index of
    0:HTMLMemo.Lines.AddStrings(NormalMemo.Lines);
    1:HTMLMemo.Lines.AddStrings(LightMemo.Lines);
    2:HTMLMemo.Lines.AddStrings(DarkMemo.Lines);
  end;
  for i := 0 to 15 do
  if (i = 15) or (i mod KleSpinEdit.Value = 0) then
  begin
    si := HEXA[i + 1] + HEXA[i + 1];
    for j := 0 to 15 do
    if (j = 15) or (j mod KleSpinEdit.Value = 0) then
    begin
      sj := si + HEXA[j + 1] + HEXA[j + 1];
      for k := 0 to 15 do
      if (k = 15) or (k mod KleSpinEdit.Value = 0) then
      begin
        sk := sj + HEXA[k + 1] + HEXA[k + 1];
        if (index = 0) or ((i + j + k >= 24) and (index = 1))
                       or ((i + j + k < 24) and (index = 2)) then
        begin
          HTMLMemo.Lines.Add('<TD BGCOLOR="#' + sk + '">');
          case KleComboBox.Itemindex of
            1 : s := sk;
            2 : s := sk[1] + sk[3] + sk[5];
            3 : s := '#' + LowerCase(sk);
            4 : s := LowerCase(sk);
            5 : s := LowerCase(sk[1] + sk[3] + sk[5]);
            else s := '#' + sk;
          end;
          if ((index = 0) and (i + j + k < 24))
            then tekst := '<FONT COLOR="#FFFFFF">' + s + '</FONT>'
            else tekst := s;
          HTMLMemo.Lines.Add(tekst);
          HTMLMemo.Lines.Add('</TD>');
          inc(teller);
          if Teller mod BreSpinEdit.Value = 0 then
          begin
            HTMLMemo.Lines.Add('</TR>');
            HTMLMemo.Lines.Add('<TR>');
          end;
        end;
      end;
    end;
  end;
  i := BreSpinEdit.Value - (Teller mod BreSpinEdit.Value);
  if i mod BreSpinEdit.Value > 0 then
  case i of
    1:begin
        HTMLMemo.Lines.Add('<TD>');
        HTMLMemo.Lines.Add('Kleuren');
        HTMLMemo.Lines.Add('</TD>');
      end;
    2:begin
        HTMLMemo.Lines.Add('<TD COLSPAN=2>');
        HTMLMemo.Lines.Add('Kleuren demo');
        HTMLMemo.Lines.Add('</TD>');
      end;
    else
      begin
        HTMLMemo.Lines.Add('<TD COLSPAN=' + IntToStr(i) + '>');
        HTMLMemo.Lines.Add('Kleuren demo van Matthijs Coster');
        HTMLMemo.Lines.Add('</TD>');
      end;
  end;
  HTMLMemo.Lines.AddStrings(BotMemo.Lines);
end;

procedure TForm1.Exit(Sender: TObject);
var n : integer;
begin
  n := (16 + KleSpinEdit.Value - 1) div KleSpinEdit.Value;
  if RadioGroup1.ItemIndex = 0 then
  begin
    KleLabel.Caption := IntToStr(n * n * n);
    HooLabel.Caption := IntToStr(n * n * n div BreSpinEdit.Value);
  end
  else
  begin
    KleLabel.Caption := IntToStr(n * n * n div 2);
    HooLabel.Caption := IntToStr(n * n * n div (2 * BreSpinEdit.Value));
  end;
end;

procedure TForm1.SavButtonClick(Sender: TObject);
begin
  if SaveDialog.Execute then
    HTMLMemo.Lines.SaveToFile(SaveDialog.FileName);
end;

end.
